/*
 * socket handling for asb
 */
#include <stdio.h>
#include <netdb.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <unistd.h>
#include <stdarg.h>
#include "netcode.h"

void gethost(struct hostent **he, char *host, int priority) {

   if (priority == AF_INET) {
      *he = gethostbyname2(host, priority);
   } else if (priority == AF_INET6) {
      *he = gethostbyname2(host, priority);
   } else {
      *he = gethostbyname2(host, AF_INET);
      if (!(*he)) *he = gethostbyname2(host, AF_INET6);
   }
}

int sockethandling(int sock, int cmd, int family, char *addr, int addrlen, int port)  {
   struct sockaddr_in  sin;
#ifdef INET6
   struct sockaddr_in6 sin6;
#endif
   struct sockaddr     *moo = NULL;
   int 		       retval = 0,
		       len = 0;
 

   if (cmd == CONNECT || cmd == BIND) {
      if (family == AF_INET) {
         bzero(&sin, sizeof(sin));
         sin.sin_family = family;
         sin.sin_port = htons(port);
         memcpy(&sin.sin_addr, addr, addrlen); 
         moo = (struct sockaddr *) &sin;
      } 
#ifdef INET6
      else if (family == AF_INET6) {
         bzero(&sin6, sizeof(sin6));
         sin6.sin6_len = sizeof(sin6);
         sin6.sin6_family = family;
         sin6.sin6_port = htons(port);
         memcpy(&sin6.sin6_addr, addr, addrlen);
         moo = (struct sockaddr *) &sin6;
      }
   }
#endif

   if (family == AF_INET)
      len = sizeof(sin);
#ifdef INET6
   else if (family == AF_INET6)
      len = sizeof(sin6);
#endif

   if (cmd == CONNECT) {
     retval = connect(sock, moo, len);
   } else if (cmd == BIND) {
     retval = bind(sock, moo, len); 
   } else if (cmd == ACCEPT) {
     retval = accept(sock, moo, &len);
     if (family == AF_INET) {

     }
#ifdef INET6
     else if (family == AF_INET6) {

     }
#endif
   }
   return retval;
}

int waitforpacket(int s, char *buffer, int len) {
   fd_set rf;

   FD_ZERO(&rf);
   FD_SET(s, &rf);
 
   select(s + 1 , &rf, NULL, NULL, NULL);
   if (FD_ISSET(s, &rf)) return recv(s, buffer, len, MSG_DONTROUTE); else return 0;
}

int sockwrite(int s, char *format, ...) {
    va_list va;
    char buffer[MAXBUF];

    va_start(va, format);
    vsnprintf(buffer, MAXBUF - 3, format, va);
    va_end(va);
    return send(s, buffer, strlen(buffer), MSG_DONTROUTE);
}


void bounce(int sock) {
   fd_set rf, 
         arf;
   int    connected = 1;
   char	 buffer[MAXBUF] = "";

   FD_ZERO(&rf);
   FD_SET(0, &rf);
   FD_SET(sock, &rf);
         
   while (connected) {
      memcpy(&arf, &rf, sizeof(rf));
      select(sock + 1 , &arf, NULL, NULL, NULL);
      bzero(buffer, sizeof(buffer));
      if (FD_ISSET(sock, &arf)) {
         connected = recv(sock, buffer, sizeof(buffer), MSG_DONTROUTE);
         if (connected) write(0, buffer, connected);
      } else if (FD_ISSET(0, &arf)) {
         connected = read(0, buffer, sizeof(buffer));
         if (connected) send(sock, buffer, connected, MSG_DONTROUTE);
      }
   }
   close(sock);
   close(0);
}
